
    <!DOCTYPE html>
    <html>
      <body>
        <style>@page {
  size: 1280px 720px;
  margin: 0;
}@media print {html, body {
  background-color: #fff;
  margin: 0;
  page-break-inside: avoid;
  break-inside: avoid-page;
}
  div.marpit > section {
    page-break-before: always;
    break-before: page;
  }

  div.marpit > section, div.marpit > section * {
    -webkit-print-color-adjust: exact !important;
    animation-delay: 0s !important;
    animation-duration: 0s !important;
    color-adjust: exact !important;
    transition: none !important;
  }

  div.marpit > svg[data-marpit-svg] {
    display: block;
    height: 100vh;
    width: 100vw;
  }
}

div.marpit > section {
  width: 1280px;
  height: 720px;

  box-sizing: border-box;
  overflow: hidden;
  position: relative;

  scroll-snap-align: center center;
}

div.marpit > section::after {
  bottom: 0;
  content: attr(data-marpit-pagination);
  padding: inherit;
  pointer-events: none;
  position: absolute;
  right: 0;
}

div.marpit > section:not([data-marpit-pagination])::after {
  display: none;
}

/* Normalization */
div.marpit > section h1 {
  font-size: 2em;
  margin: 0.67em 0;
}

div.marpit > section video::-webkit-media-controls {
  will-change: transform;
}</style>
        <div class="marpit"><section id="1" data-marpit-fragments="10">
<h1>Zero-downtime deployment</h1>
<p>Реализуйте zero-downtime deployment по стратегии Rolling Update с помощью Kubernetes. Убедитесь, что во время деплоя приложение будет доступно без прерывания.</p>
<h2>Ссылки</h2>
<ul>
<li data-marpit-fragment="1"><a href="https://thenewstack.io/deployment-strategies/">Six Strategies for Application Deployment</a> - описание стратегий деплоя с визуализацией и сравнением</li>
<li data-marpit-fragment="2"><a href="https://guides.hexlet.io/check-list-of-engineering-practices/">Чек-лист хороших инженерных практик в компаниях</a></li>
<li data-marpit-fragment="3"><a href="https://ru.hexlet.io/blog/posts/environment">Среды разработки</a></li>
</ul>
<h2>Задачи</h2>
<ul>
<li data-marpit-fragment="4">Соберите и запуште на Dockerhub свой образ на базе <a href="https://github.com/hexlet-components/devops-example-app">devops-example-app</a>, укажите версию (тег), например - <code>yourname/devops-example-app:v1</code></li>
<li data-marpit-fragment="5">Создайте в Digital Ocean отдельный сервер (дроплет) для мониторинга</li>
<li data-marpit-fragment="6">Установите на него агент Datadog</li>
<li data-marpit-fragment="7">Добавьте хелфчек (healthcheck), который будет запрашивать внешний адрес приложения, которое находится в кластере Kubernetes. Таким образом проверяя его текущее состояние</li>
<li data-marpit-fragment="8">Используйте созданный ранее образ в файлах конфигурации деплоя. Выполните и промониторьте деплой приложения</li>
<li data-marpit-fragment="9">Создайте новый релиз с новым тегом (например - <code>yourname/devops-example-app:v2</code>) и задеплойте его. Убедитесь, что в этот приложение было доступно и мониторинг не сработал</li>
<li data-marpit-fragment="10">Откатите релиз на предыдущую версию (измените тег образа)</li>
</ul>
<p>Таким образом в любой момент времени приложение будет доступно с новой или старой версией.</p>
</section>
</div>
      </body>
    </html>
  